// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockPipelineTemplates is an autogenerated mock type for the PipelineTemplates type
type MockPipelineTemplates struct {
	mock.Mock
}

// CreatePipelineTemplate provides a mock function with given fields: ctx, pipelineTemplate
func (_m *MockPipelineTemplates) CreatePipelineTemplate(ctx context.Context, pipelineTemplate *models.PipelineTemplate) (*models.PipelineTemplate, error) {
	ret := _m.Called(ctx, pipelineTemplate)

	if len(ret) == 0 {
		panic("no return value specified for CreatePipelineTemplate")
	}

	var r0 *models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineTemplate) (*models.PipelineTemplate, error)); ok {
		return rf(ctx, pipelineTemplate)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineTemplate) *models.PipelineTemplate); ok {
		r0 = rf(ctx, pipelineTemplate)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.PipelineTemplate) error); ok {
		r1 = rf(ctx, pipelineTemplate)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeletePipelineTemplate provides a mock function with given fields: ctx, pipelineTemplate
func (_m *MockPipelineTemplates) DeletePipelineTemplate(ctx context.Context, pipelineTemplate *models.PipelineTemplate) error {
	ret := _m.Called(ctx, pipelineTemplate)

	if len(ret) == 0 {
		panic("no return value specified for DeletePipelineTemplate")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineTemplate) error); ok {
		r0 = rf(ctx, pipelineTemplate)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetPipelineTemplateByID provides a mock function with given fields: ctx, id
func (_m *MockPipelineTemplates) GetPipelineTemplateByID(ctx context.Context, id string) (*models.PipelineTemplate, error) {
	ret := _m.Called(ctx, id)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplateByID")
	}

	var r0 *models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PipelineTemplate, error)); ok {
		return rf(ctx, id)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PipelineTemplate); ok {
		r0 = rf(ctx, id)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineTemplateByPRN provides a mock function with given fields: ctx, prn
func (_m *MockPipelineTemplates) GetPipelineTemplateByPRN(ctx context.Context, prn string) (*models.PipelineTemplate, error) {
	ret := _m.Called(ctx, prn)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplateByPRN")
	}

	var r0 *models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, string) (*models.PipelineTemplate, error)); ok {
		return rf(ctx, prn)
	}
	if rf, ok := ret.Get(0).(func(context.Context, string) *models.PipelineTemplate); ok {
		r0 = rf(ctx, prn)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, string) error); ok {
		r1 = rf(ctx, prn)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetPipelineTemplates provides a mock function with given fields: ctx, input
func (_m *MockPipelineTemplates) GetPipelineTemplates(ctx context.Context, input *GetPipelineTemplatesInput) (*PipelineTemplatesResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetPipelineTemplates")
	}

	var r0 *PipelineTemplatesResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelineTemplatesInput) (*PipelineTemplatesResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetPipelineTemplatesInput) *PipelineTemplatesResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*PipelineTemplatesResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetPipelineTemplatesInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdatePipelineTemplate provides a mock function with given fields: ctx, pipelineTemplate
func (_m *MockPipelineTemplates) UpdatePipelineTemplate(ctx context.Context, pipelineTemplate *models.PipelineTemplate) (*models.PipelineTemplate, error) {
	ret := _m.Called(ctx, pipelineTemplate)

	if len(ret) == 0 {
		panic("no return value specified for UpdatePipelineTemplate")
	}

	var r0 *models.PipelineTemplate
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineTemplate) (*models.PipelineTemplate, error)); ok {
		return rf(ctx, pipelineTemplate)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.PipelineTemplate) *models.PipelineTemplate); ok {
		r0 = rf(ctx, pipelineTemplate)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.PipelineTemplate)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.PipelineTemplate) error); ok {
		r1 = rf(ctx, pipelineTemplate)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockPipelineTemplates creates a new instance of MockPipelineTemplates. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockPipelineTemplates(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockPipelineTemplates {
	mock := &MockPipelineTemplates{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
